unit UDessin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    Index1: TMenuItem;
    StatusBar1: TStatusBar;
    Fichier2: TMenuItem;
    Quitter2: TMenuItem;
    N2: TMenuItem;
    Configurationdelimpression1: TMenuItem;
    Imprimer1: TMenuItem;
    N3: TMenuItem;
    Enregistrersous1: TMenuItem;
    Enregistrer1: TMenuItem;
    Ouvrir1: TMenuItem;
    Nouveau2: TMenuItem;
    Couleur1: TMenuItem;
    ColorDialog1: TColorDialog;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Formes1: TMenuItem;
    courbes1: TMenuItem;
    Polygone1: TMenuItem;
    Rectangle1: TMenuItem;
    Cercle1: TMenuItem;
    Effacer1: TMenuItem;
    N1: TMenuItem;
    Ligne1: TMenuItem;
    Fond1: TMenuItem;
    Remplissage1: TMenuItem;
    Contour1: TMenuItem;
    Plein1: TMenuItem;
    Epaisseur1: TMenuItem;
    N51: TMenuItem;
    N41: TMenuItem;
    N31: TMenuItem;
    N21: TMenuItem;
    N11: TMenuItem;
    Zoom1: TMenuItem;
    N501: TMenuItem;
    N1001: TMenuItem;
    N2001: TMenuItem;
    N4: TMenuItem;
    Panel1: TPanel;
    procedure Quitter2Click(Sender: TObject);
    procedure Nouveau2Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Enregistrersous1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Enregistrer1Click(Sender: TObject);
    procedure Efface;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure menuFormesClick(Sender: TObject);
    procedure Effacer1Click(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Ligne1Click(Sender: TObject);
    procedure Fond1Click(Sender: TObject);
    procedure Plein1Click(Sender: TObject);
    procedure Contour1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N501Click(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    procedure N2001Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Epaisseur1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
  private
    { Dclarations prives }
    { coordonnes du point de rfrence ; 1er clic pour polygone, prcdent
      pour la courbe, dpart du drag pour un rectangle ou cercle }
    X0,Y0:integer;
    BrushStyle : TBrushStyle;
    Brushcolor : TColor;
    { flag pour savoir si on est en cours de trac de ligne brise }
    bPolygoneStarted : boolean;
    { coefficient de zoom }
    ZoomFactor : single;
    { transforme une coordonne cran en coord. relle en fonction du zoom }
    function zoom(X:integer):integer;
    { remet la status bar  sa place aprs un zoom (bug Delphi ??) }
    procedure RefreshBar(sb:TStatusBar);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ transforme une coordonne relle/cran en coord. logique/image en fonction du zoom }
function TForm1.zoom(X:integer):integer;
begin
  result:=round(X/ZoomFactor);
end;

{ remet la status bar  sa place aprs un zoom (bug Delphi ??) }
procedure TForm1.RefreshBar(sb:TStatusBar);
begin
  //sb.align:=alNone;
  sb.height:=19;
  //sb.align:=alBottom;
end;

procedure TForm1.Quitter2Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Efface;
begin
  { remplir toute la surface avec la couleur de fond }
  with Image1.Canvas do FillRect(ClipRect);
  { pour une ligne brise, enlever le flag "en cours" }
  bPolygoneStarted:=False;
end;

procedure TForm1.Nouveau2Click(Sender: TObject);
begin
  { efface l'image et vide le nom de fichier }
  Efface;
  SaveDialog1.Filename:='';
end;

procedure TForm1.Ouvrir1Click(Sender: TObject);
begin
  with OpenDialog1 do
    if Execute then begin
      { charge le fichier choisi dans l'image }
      Image1.picture.LoadFromFile(FileName);
      { et stocke le nom du fichier pour la sauvegarde }
      saveDialog1.filename:=FileName;
      { pour une ligne brise, enlever le flag "en cours" }
      bPolygoneStarted:=False;
    end;
end;

procedure TForm1.EnregistrerSous1Click(Sender: TObject);
begin
  if SaveDialog1.execute then Image1.picture.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Enregistrer1Click(Sender: TObject);
begin
  with saveDialog1 do
    if filename<>'' then
      { le fichier est connu }
      Image1.picture.SaveToFile(FileName)
    else
      { nouveau fichier, demander un nom }
      if execute then Image1.picture.SaveToFile(FileName);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { affiche coordonnes souris (logiques/image) }
  StatusBar1.simpleText := '( X=' + IntToStr(zoom(X)) + ', Y=' + IntToStr(zoom(Y)) + ')';
  { rinitialise le point d'origine sauf pour la ligne brise en cours de trac}
  if bPolygoneStarted then
    Image1.Canvas.lineTo(zoom(X),zoom(Y))
  else begin
    Image1.Canvas.PenPos:=point(zoom(X),zoom(Y));
    X0:=X;  { ancienne valeur de X }
    Y0:=Y;  { ancienne valeur de Y }
    if Rectangle1.checked or cercle1.checked then begin
      { pour une forme, dmarre le mode inverse vido pour le drag }
      Image1.Canvas.Pen.Mode := pmXOr;
      Image1.Canvas.Brush.Style := bsSolid;
    end else if Polygone1.checked then begin
      { pour une nouvelle ligne brise, le flag "en cours" est mis dans OnClic }
      { bPolygoneStarted:=True; }
    end;
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  { affiche coordonnes souris }
  StatusBar1.simpleText := '( X=' + IntToStr(zoom(X)) + ', Y=' + IntToStr(zoom(Y)) + ')';
  if ssLeft in Shift then begin
    { le bouton gauche est enfonc (entre autre), on dessine }
    if courbes1.checked then
      Image1.Canvas.lineTo(zoom(X),zoom(Y))
    else if Polygone1.checked then
      { ne rien dessiner pour la ligne brise cf MouseDown }
    else if Rectangle1.checked then
      { tracer 2 fois de suite la mme chose en xor rtablit l'image originale }
     begin
      Image1.canvas.rectangle(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X0),zoom(Y0));
      X0:=X;
      Y0:=Y;
      Image1.canvas.rectangle(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X0),zoom(Y0));
     end
    else if Cercle1.checked then
     begin
      Image1.canvas.ellipse(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X0),zoom(Y0));
      X0:=X;
      Y0:=Y;
      Image1.canvas.ellipse(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X0),zoom(Y0));
     end;
  end;
end;

procedure TForm1.menuFormesClick(Sender: TObject);
begin
  (sender as TMenuItem).checked:=True;
  { enlever le flag "en cours" de la ligne brise }
  bPolygoneStarted:=False;
end;

procedure TForm1.Effacer1Click(Sender: TObject);
begin
  Efface;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { au relach de la souris, il faut effacer la trace inverse puis tracer la
  forme dfinitive rectangle ou cercle}
  if Rectangle1.checked then
     begin
      Image1.canvas.rectangle(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X),zoom(Y));
      Image1.Canvas.Pen.Mode := pmCopy;
      Image1.Canvas.brush.Style := brushStyle;
      Image1.canvas.rectangle(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X),zoom(Y));
     end
  else if Cercle1.checked then
     begin
      Image1.canvas.ellipse(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X),zoom(Y));
      Image1.Canvas.Pen.Mode := pmCopy;
      Image1.Canvas.brush.Style := brushStyle;
      Image1.canvas.ellipse(Image1.canvas.penpos.X,Image1.canvas.penpos.Y,zoom(X),zoom(Y));
     end;
end;

procedure TForm1.Ligne1Click(Sender: TObject);
begin
  { changer couleur pinceau selon choix utilisateur}
  if colorDialog1.execute then Image1.canvas.pen.color:=colorDialog1.color;
end;

procedure TForm1.Fond1Click(Sender: TObject);
begin
  { changer couleur brosse selon choix utilisateur}
  if colorDialog1.execute then Image1.canvas.brush.color:=colorDialog1.color;
  { changer galement pour le fond de fentre }
  brushColor:=Image1.canvas.brush.color;

end;


procedure TForm1.Plein1Click(Sender: TObject);
begin
  { dessine en opaque }
   (sender as TMenuItem).checked:=True;
   brushStyle := bsSolid;
   Image1.canvas.brush.color:=brushColor;
end;

procedure TForm1.Contour1Click(Sender: TObject);
begin
  { dessine sans remplissage }
   (sender as TMenuItem).checked:=True;
   brushStyle := bsClear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { par dfaut au dmarrage, fond blanc plein }
  brushStyle := bsSolid;
  brushColor := clWhite;
  { enlever le flag "en cours" de la ligne brise }
  bPolygoneStarted:=False;
  ZoomFactor:=1;
  refreshBar(StatusBar1);
end;
procedure TForm1.N501Click(Sender: TObject);
begin
  { zoom 1/2}
  with image1 do begin
    autosize:=false;
    stretch:=true;
    panel1.scaleby(50,100);
    ZoomFactor:=ZoomFactor/2;
  end;
  refreshBar(StatusBar1);
end;

procedure TForm1.N1001Click(Sender: TObject);
begin
  { zoom 100%}
  with image1 do begin
    autosize:=True; { rappel }
    stretch:=false; { rappel }
    align:=alClient;
    panel1.align:=alClient;
    scaleby(100,100);
    panel1.align:=alNone;
    ZoomFactor:=1;
  end;
  refreshBar(StatusBar1);
end;

procedure TForm1.N2001Click(Sender: TObject);
begin
  { zoom x2}
  with image1 do begin
    autosize:=false;
    stretch:=true;
    panel1.scaleby(200,100);
    ZoomFactor:=ZoomFactor*2;
  end;
  refreshBar(StatusBar1);
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
  { fermer le polygone avec le double clic}
  if Polygone1.checked then Image1.Canvas.lineTo(zoom(X0),zoom(Y0));
  { enlever le flag "en cours" de la ligne brise }
  bPolygoneStarted:=False;
end;

procedure TForm1.Epaisseur1Click(Sender: TObject);
begin
  (sender as TMenuItem).checked:=True;
  Image1.canvas.pen.width:= strToIntDef((sender as TMenuItem).caption,1);
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  { pour une nouvelle ligne brise, mettre le flag "en cours" }
  if Polygone1.checked and not bPolygoneStarted then bPolygoneStarted:=True;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
  Application.MessageBox('TP Delphi  l''IUT de Montreuil'#13#13+
                         '  1998 by Franois GAILLARD',
                         'PDessin : un exemple de programme de dessin avec Delphi',
                         MB_OK or MB_APPLMODAL or MB_ICONINFORMATION);
end;

end.

